
## pip install requests

import requests

def get_all_employees():
    response = requests.get("http://127.0.0.1:3399/api/employees/")
    if response.status_code == 200:
        try:
            dict_data = response.json()
        except:
            print("Status Code :", response.status_code)
            print("Response is not available in JSON format")
        else:
            print("Status Code :", response.status_code)
            print(dict_data)

    else:
        print("Status Code :", response.status_code)
        print("Something went wrong")

def get_employee_by_id(id):
    response = requests.get("http://127.0.0.1:3399/api/employees/"+id+"/")
    if response.status_code == 200:
        try:
            dict_data = response.json()
        except:
            print("Status Code :", response.status_code)
            print("Response is not available in JSON format")
        else:
            print("Status Code :", response.status_code)
            print(dict_data)

    elif response.status_code == 404:
        print("Status Code :", response.status_code)
        print("Requested employee not available")

    else:
        print("Status Code :", response.status_code)
        print("Something went wrong")


def delete_employee_by_id(id):
    response = requests.delete("http://127.0.0.1:3399/api/employees/"+id+"/")
    if response.status_code == 204:
        print("Status Code :", response.status_code)
        print("Requested employee deleted successfully")

    elif response.status_code == 404:
        print("Status Code :", response.status_code)
        print("Requested employee not available to delete")

    else:
        print("Status Code :", response.status_code)
        print("Something went wrong")

def create_employee_data():
    employee_data = {
        "ename": "Gani",
        "salary": 45000,
        "city": "Chennai",
        "mobile": 222221111,
    }
    response = requests.post("http://127.0.0.1:3399/api/employees/", data=employee_data)
    if response.status_code == 201:
        try:
            dict_data = response.json()
        except:
            print("Status Code :", response.status_code)
            print("Response is not available in JSON format")
        else:
            print("Status Code :", response.status_code)
            print(dict_data)

    elif response.status_code == 400:
        print("Status Code :", response.status_code)
        print("Requested employee data not created successfully")

    else:
        print("Status Code :", response.status_code)
        print("Something went wrong")


def update_employee_by_id(id):
    employee_data = {
        "ename": input("Employee Name is :"),
        "salary": 47000,
        "city": "Chennai",
        "mobile": 222221111,
    }
    response = requests.put("http://127.0.0.1:3399/api/employees/"+id+'/', data=employee_data)
    if response.status_code == 200:
        try:
            dict_data = response.json()
        except:
            print("Status Code :", response.status_code)
            print("Response is not available in JSON format")
        else:
            print("Status Code :", response.status_code)
            print(dict_data)

    elif response.status_code == 400:
        print("Status Code :", response.status_code)
        print("Requested employee data not updated successfully")

    else:
        print("Status Code :", response.status_code)
        print("Something went wrong")





print("Please select your required operation :")
while True:
    print("1. Getting all employees")
    print("2. Creating new employee")
    print("3. Getting employee by id")
    print("4. Updating employee by id")
    print("5. Deleting employee by id")
    print("6. Do you want to Exit?")

    value = input()

    if value == "1":
        get_all_employees()
        break

    elif value == "2":
        create_employee_data()
        break

    elif value == "3":
        id = input("Enter any employee id: ")
        get_employee_by_id(id)
        break

    elif value == "4":
        id = input("Enter any employee id: ")
        update_employee_by_id(id)
        break

    elif value == "5":
        id = input("Enter any employee id: ")
        delete_employee_by_id(id)
        break

    elif value == "6":
        print("Thank you!")
        break
    else:
        print("Please select valid option only (1 to 6)")





